searchData={"items":[{"type":"task","title":"mix multilingual.routes","doc":"","ref":"Mix.Tasks.Multilingual.Routes.html"},{"type":"function","title":"Mix.Tasks.Multilingual.Routes.run/1","doc":"","ref":"Mix.Tasks.Multilingual.Routes.html#run/1"},{"type":"module","title":"Multilingual.Components","doc":"","ref":"Multilingual.Components.html"},{"type":"function","title":"Multilingual.Components.rel_links/1","doc":"Create a list of rel links for the current page.","ref":"Multilingual.Components.html#rel_links/1"},{"type":"function","title":"Attributes - Multilingual.Components.rel_links/1","doc":"* `rels` (`:list`)","ref":"Multilingual.Components.html#rel_links/1-attributes"},{"type":"module","title":"Multilingual.HTML","doc":"","ref":"Multilingual.HTML.html"},{"type":"function","title":"Multilingual.HTML.get_rel_links/1","doc":"Builds a list of data for rel links for the document head.","ref":"Multilingual.HTML.html#get_rel_links/1"},{"type":"function","title":"Example - Multilingual.HTML.get_rel_links/1","doc":"In the router:\n\n    scope \"/\", MyAppWeb do\n      get \"/about\", PageController, :index, metadata(\"en\")\n      get \"/it/chi-siamo\", PageController, :index, metadata(\"it\")\n    end\n\nIn the ` ` of the layout template:\n\n    <%= get_rel_links(@conn) %>\n\nResult:","ref":"Multilingual.HTML.html#get_rel_links/1-example"},{"type":"module","title":"Multilingual.Hooks.PutGettextLocale","doc":"Sets the Gettext locale in the LiveView socket\nbased on the locale stored in the socket's private data.\n\nThis hook must follow the StoreView hook in the LiveView's\n`on_mount` hook list.","ref":"Multilingual.Hooks.PutGettextLocale.html"},{"type":"module","title":"Example - Multilingual.Hooks.PutGettextLocale","doc":"defmodule MyAppWeb.HomeLive do\n      use MyAppWeb, :live_view\n\n      alias Multilingual.Hooks.StoreView\n      alias Multilingual.Hooks.PutGettextLocale\n\n      on_mount {StoreView, default_locale: \"en\"}\n      on_mount PutGettextLocale\n    end","ref":"Multilingual.Hooks.PutGettextLocale.html#module-example"},{"type":"function","title":"Multilingual.Hooks.PutGettextLocale.on_mount/4","doc":"","ref":"Multilingual.Hooks.PutGettextLocale.html#on_mount/4"},{"type":"module","title":"Multilingual.Hooks.StoreView","doc":"Store the view information in the LiveView socket's private data.\n\nThis hook **must** be registered for each LiveView in order\nto enable all other Multilingual features in Phoenix live views.","ref":"Multilingual.Hooks.StoreView.html"},{"type":"module","title":"Example - Multilingual.Hooks.StoreView","doc":"defmodule MyAppWeb.HomeLive do\n      use MyAppWeb, :live_view\n\n      alias Multilingual.Hooks.StoreView\n\n      on_mount {StoreView, default_locale: \"en\"}\n    end","ref":"Multilingual.Hooks.StoreView.html#module-example"},{"type":"function","title":"Multilingual.Hooks.StoreView.on_mount/4","doc":"","ref":"Multilingual.Hooks.StoreView.html#on_mount/4"},{"type":"module","title":"Multilingual.Plugs.PutGettextLocale","doc":"","ref":"Multilingual.Plugs.PutGettextLocale.html"},{"type":"function","title":"Multilingual.Plugs.PutGettextLocale.call/2","doc":"","ref":"Multilingual.Plugs.PutGettextLocale.html#call/2"},{"type":"function","title":"Multilingual.Plugs.PutGettextLocale.init/1","doc":"","ref":"Multilingual.Plugs.PutGettextLocale.html#init/1"},{"type":"module","title":"Multilingual.Plugs.RedirectIncoming","doc":"Redirects incoming requests to the user's preferred language.\n\nUse this plug in your router pipeline to redirect incoming requests\nto the user's preferred language, as indicated by the \"Accept-Language\"\nheader.\n\nThis plug should be preceded by another plug that actually does the\nfetching and parsing of the \"Accept-Language\" header, such as\n`Cldr.Plug.AcceptLanguage`.\n\nTwo options are required:\n\n* `:accept_locale_source` - the module that provides the user's preferred\n  language. Currently, only `Cldr` is supported,\n* `:nearest_known` - a function that returns the nearest known locale\n  to the user's preferred locale.","ref":"Multilingual.Plugs.RedirectIncoming.html"},{"type":"module","title":"Example - Multilingual.Plugs.RedirectIncoming","doc":"pipeline :browser do\n      ...\n      plug Cldr.Plug.AcceptLanguage, cldr_backend: MyApp.Cldr\n      plug RedirectIncoming,\n        accept_locale_source: Cldr,\n        nearest_known: &MyApp.nearest_known/1\n      ...\n    end","ref":"Multilingual.Plugs.RedirectIncoming.html#module-example"},{"type":"function","title":"Multilingual.Plugs.RedirectIncoming.call/2","doc":"If a request has a \"Referer\" that is not the current host,\nwe may want to redirect to the user's preferred language,\nas indicated by the \"Accept-Language\" header.","ref":"Multilingual.Plugs.RedirectIncoming.html#call/2"},{"type":"function","title":"Multilingual.Plugs.RedirectIncoming.init/1","doc":"","ref":"Multilingual.Plugs.RedirectIncoming.html#init/1"},{"type":"function","title":"Multilingual.Plugs.RedirectIncoming.nearest_known/2","doc":"","ref":"Multilingual.Plugs.RedirectIncoming.html#nearest_known/2"},{"type":"module","title":"Multilingual.Plugs.StoreView","doc":"Store the view information in the connection's private data.\n\nThis plug **must** be used in the router pipeline in order\nto enable all other Multilingual features in Phoenix views.","ref":"Multilingual.Plugs.StoreView.html"},{"type":"module","title":"Example - Multilingual.Plugs.StoreView","doc":"defmodule MyAppWeb.Router do\n      use MyAppWeb, :router\n\n      alias Multilingual.Plugs.StoreView\n\n      pipeline :browser do\n        ...\n        plug StoreView, default_locale: \"en\"\n      end\n    end","ref":"Multilingual.Plugs.StoreView.html#module-example"},{"type":"function","title":"Multilingual.Plugs.StoreView.call/2","doc":"","ref":"Multilingual.Plugs.StoreView.html#call/2"},{"type":"function","title":"Multilingual.Plugs.StoreView.init/1","doc":"","ref":"Multilingual.Plugs.StoreView.html#init/1"},{"type":"module","title":"Multilingual.Routes","doc":"","ref":"Multilingual.Routes.html"},{"type":"function","title":"Multilingual.Routes.build_page_mapping/2","doc":"Builds a mapping of locales to paths for the current page.","ref":"Multilingual.Routes.html#build_page_mapping/2"},{"type":"function","title":"Examples - Multilingual.Routes.build_page_mapping/2","doc":"In the router:\n\n    scope \"/\", MyAppWeb do\n      get \"/about\", PageController, :index, metadata(\"en\")\n      get \"/it/chi-siamo\", PageController, :index, metadata(\"it\")\n    end\n\n    > Multilingual.Routes.build_page_mapping(Router, \"/about\")\n    {:ok, %{\"en\" => \"/about\", \"it\" => \"/it/chi-siamo\"}}\n\nThe result can be used to create a language switcher in the view.\n\n    <% locales = [\"en\", \"it\"] %>\n    <% locale = Multilingual.View.fetch_key(@conn, :locale) %>\n    <% path = Multilingual.View.fetch_key(@conn, :route) %>\n    <% {:ok, mapping} = Multilingual.Routes.build_page_mapping(@conn, path) %>\n     \n       \n        <%= for lcl <- locales do %>\n          <%= if lcl == locale do %>\n             <%= lcl %> \n          <% else %>\n            <%= if mapping[lcl] do %>\n                <%= lcl %>  \n            <% end %>\n          <% end %>\n        <% end %>","ref":"Multilingual.Routes.html#build_page_mapping/2-examples"},{"type":"function","title":"Multilingual.Routes.locale/1","doc":"","ref":"Multilingual.Routes.html#locale/1"},{"type":"function","title":"Multilingual.Routes.localized_path/3","doc":"Returns the equivalent localized path for the given path and locale.\n\nIf the path is not found, it returns `nil`.","ref":"Multilingual.Routes.html#localized_path/3"},{"type":"function","title":"Examples - Multilingual.Routes.localized_path/3","doc":"In the router:\n\n    scope \"/\", MyAppWeb do\n      get \"/about\", PageController, :index, metadata(\"en\")\n      get \"/it/chi-siamo\", PageController, :index, metadata(\"it\")\n    end\n\n    > Multilingual.Routes.localized_path(MyAppWeb.Router, \"/about\", \"it\")\n    \"/it/chi-siamo\"","ref":"Multilingual.Routes.html#localized_path/3-examples"},{"type":"function","title":"Multilingual.Routes.metadata/1","doc":"Creates metadata for multilingual routes.","ref":"Multilingual.Routes.html#metadata/1"},{"type":"function","title":"Examples - Multilingual.Routes.metadata/1","doc":"iex> Multilingual.Routes.metadata(\"it\")\n    [metadata: %{multilingual: %{locale: \"it\"}}]","ref":"Multilingual.Routes.html#metadata/1-examples"},{"type":"function","title":"Multilingual.Routes.path_locale/2","doc":"Returns the locale from the metadata of the route which provides\nthe requested path.","ref":"Multilingual.Routes.html#path_locale/2"},{"type":"module","title":"Multilingual.Routes.Route","doc":"A struct to hold route information returned by Phoenix.Router.routes/1.\n\nThis struct only carries data from the Router.","ref":"Multilingual.Routes.Route.html"},{"type":"function","title":"Multilingual.Routes.Route.attrs/0","doc":"","ref":"Multilingual.Routes.Route.html#attrs/0"},{"type":"module","title":"Multilingual.Routes.RouteInfo","doc":"A struct to hold route information supplied by Phoenix.Router.route_info/4.\n\nThis struct is specific to a path and has parameter infomation.","ref":"Multilingual.Routes.RouteInfo.html"},{"type":"function","title":"Multilingual.Routes.RouteInfo.attrs/0","doc":"","ref":"Multilingual.Routes.RouteInfo.html#attrs/0"},{"type":"module","title":"Multilingual.View","doc":"","ref":"Multilingual.View.html"},{"type":"function","title":"Multilingual.View.fetch_key/2","doc":"Fetches a key from the private View data in the connection and raises\nan error is not view is found.","ref":"Multilingual.View.html#fetch_key/2"},{"type":"function","title":"Examples - Multilingual.View.fetch_key/2","doc":"iex> view = %Multilingual.View{locale: \"en\", path: \"/about\"}\n    ...> conn = Plug.Conn.put_private(%Plug.Conn{}, :multilingual, view)\n    ...> Multilingual.View.fetch_key(conn, :path)\n    \"/about\"\n\n    iex> view = %Multilingual.View{locale: \"en\", path: \"/about\"}\n    ...> conn = Plug.Conn.put_private(%Plug.Conn{}, :multilingual, view)\n    ...> Multilingual.View.fetch_key(conn, :bad_key)\n    ** (FunctionClauseError) no function clause matching in Multilingual.View.fetch_key/2\n\n    iex> assert_raise Multilingual.MissingViewDataInConnError, fn ->\n    ...>  Multilingual.View.fetch_key(%Plug.Conn{}, :locale)\n    ...> end\n\n    iex> view = %Multilingual.View{locale: \"en\", path: \"/about\"}\n    ...> socket = Phoenix.LiveView.put_private(%Phoenix.LiveView.Socket{}, :multilingual, view)\n    ...> Multilingual.View.fetch_key(socket, :path)\n    \"/about\"\n\n    iex> view = %Multilingual.View{locale: \"en\", path: \"/about\"}\n    ...> socket = Phoenix.LiveView.put_private(%Phoenix.LiveView.Socket{}, :multilingual, view)\n    ...> Multilingual.View.fetch_key(socket, :bad_key)\n    ** (FunctionClauseError) no function clause matching in Multilingual.View.fetch_key/2\n\n    iex> assert_raise Multilingual.MissingViewDataInSocketError, fn ->\n    ...>  Multilingual.View.fetch_key(%Phoenix.LiveView.Socket{}, :locale)\n    ...> end","ref":"Multilingual.View.html#fetch_key/2-examples"},{"type":"function","title":"Multilingual.View.get_key/2","doc":"Fetches a key from the private View data in the connection or socket.\nReturns nil if no view data is found.\n\nRaises an error if an erroneous key is requested.","ref":"Multilingual.View.html#get_key/2"},{"type":"function","title":"Examples - Multilingual.View.get_key/2","doc":"iex> view = %Multilingual.View{locale: \"en\", path: \"/about\"}\n    ...> conn = Plug.Conn.put_private(%Plug.Conn{}, :multilingual, view)\n    ...> Multilingual.View.get_key(conn, :path)\n    \"/about\"\n\n    iex> view = %Multilingual.View{locale: \"en\", path: \"/about\"}\n    ...> conn = Plug.Conn.put_private(%Plug.Conn{}, :multilingual, view)\n    ...> Multilingual.View.get_key(conn, :bad_key)\n    ** (FunctionClauseError) no function clause matching in Multilingual.View.get_key/2\n\n    iex> Multilingual.View.get_key(%Plug.Conn{}, :path)\n    nil\n\n    iex> view = %Multilingual.View{locale: \"en\", path: \"/about\"}\n    ...> socket = Phoenix.LiveView.put_private(%Phoenix.LiveView.Socket{}, :multilingual, view)\n    ...> Multilingual.View.get_key(socket, :path)\n    \"/about\"\n\n    iex> view = %Multilingual.View{locale: \"en\", path: \"/about\"}\n    ...> socket = Phoenix.LiveView.put_private(%Phoenix.LiveView.Socket{}, :multilingual, view)\n    ...> Multilingual.View.get_key(socket, :bad_key)\n    ** (FunctionClauseError) no function clause matching in Multilingual.View.get_key/2\n\n    iex> Multilingual.View.get_key(%Phoenix.LiveView.Socket{}, :locale)\n    nil","ref":"Multilingual.View.html#get_key/2-examples"},{"type":"exception","title":"Multilingual.MissingViewDataInConnError","doc":"","ref":"Multilingual.MissingViewDataInConnError.html"},{"type":"function","title":"Multilingual.MissingViewDataInConnError.message/1","doc":"","ref":"Multilingual.MissingViewDataInConnError.html#message/1"},{"type":"exception","title":"Multilingual.MissingViewDataInSocketError","doc":"","ref":"Multilingual.MissingViewDataInSocketError.html"},{"type":"function","title":"Multilingual.MissingViewDataInSocketError.message/1","doc":"","ref":"Multilingual.MissingViewDataInSocketError.html#message/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}